#include "conv.h"

void conv(type_t I[C][H][H], type_t W[M][C][R][R], type_t O[M][E][E]) {
	// LOF
	for(int m = 0; m < M; m++) {
		// LIF
		for(int c = 0; c < C ; c++) {
			// LSY
			for(int y = 0; y < E; y++) {
				// LSX
				for(int x = 0; x < E; x++) {
					// LFY
					for(int k = 0; k < R; k++) {
						// LFX
						for(int l = 0; l < R; l++) {
							int h1 = y * S - P + k;
							int h2 = x * S - P + l;
							type_t i = (h1 < 0 || h1 >= H || h2 < 0 || h2 >= H)? 0 : I[c][h1][h2];

							O[m][y][x] += i * W[m][c][k][l];
						}
					}
				}
			}
		}
	}
}
