#include <cstdio>
#include <cstdlib>

#include "conv_tb.h"
#include "conv.h"

int main(void) {
	type_t *_I = (type_t *) malloc(C * F * F * sizeof(type_t));
	type_t *_W = (type_t *) malloc(M * C * R * R * sizeof(type_t));
	type_t *_O = (type_t *) calloc(M * E * E, sizeof(type_t));
	type_t (*I)[F][F] = (type_t (*)[F][F]) _I;
	type_t (*W)[C][R][R] = (type_t (*)[C][R][R]) _W;
	type_t (*O)[E][E] = (type_t (*)[E][E]) _O;

	srand(1);
	for(unsigned c = 0; c < C; c++)
		for(unsigned x = 0; x < F; x++)
			for(unsigned y = 0; y < F; y++)
				I[c][x][y] = (x < P || x >= (H + P) || y < P || y >= (H + P))? 0 : (rand() % RANDROOF);
	for(unsigned i = 0; i < M * C * R * R; i++)
		_W[i] = rand() % RANDROOF;

	conv(I, W, O);

	FILE *opf = fopen("output.bin", "wb");
	fwrite(_O, sizeof(type_t), M * E * E, opf);
	fclose(opf);

	if(_I) free(_I);
	if(_W) free(_W);
	if(_O) free(_O);

	return EXIT_SUCCESS;
}
